#include "IntKeyList.h"

ClassImp(IntKeyCntr)
ClassImp(IntKeyList)

//___________________________________________________________________________________
void IntKeyList::AddKey(const Int_t Key)
{
   UInt_t jk, Cnt0,  Cnt1;
   IntKeyCntr *Key0, *Key1;
   for (jk = 0; jk < fCount; ++jk) {
      Key1 = (IntKeyCntr *)fKeyStat->At(jk);
      if (Key1->fKey == Key) {
         Cnt1 = Key1->Inc(); break; //Incrementing key counter if the key exists
      }
   }
   if (jk < fCount) { //Checking the key order
      while (jk > 0) {
         Key0 = (IntKeyCntr *)fKeyStat->At(--jk);
         Cnt0 = Key0->fCount;
         if (Cnt1 <= Cnt0) break;
         Key1->fCount = Cnt0; //swapping keys if neccessary
         Key1->fKey = Key0->fKey;
         Key0->fCount = Cnt1;
         Key0->fKey = Key;
         Key1 = Key0;
      }
   } else new((*fKeyStat)[fCount++]) IntKeyCntr(Key);
   ++fTot;
}

